# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`auditd`](#auditd): audit daemon
* [`auditd::audisp`](#auditd--audisp): audit event dispatcher

#### Private Classes

* `auditd::config`: auditd configuration
* `auditd::package`: auditd package management
* `auditd::service`: auditd service management

### Defined types

* [`auditd::plugin`](#auditd--plugin): Create plugin files
* [`auditd::rule`](#auditd--rule): Creates auditd rules

### Data types

* [`Auditd::Audisp::Conf`](#Auditd--Audisp--Conf): audispd.conf configuration file parameters
* [`Auditd::Conf`](#Auditd--Conf): auditd.conf configuration file parameters
* [`Auditd::Plugins`](#Auditd--Plugins): auditd plugin parameters
* [`Auditd::Rules`](#Auditd--Rules): auditd rule parameters

## Classes

### <a name="auditd"></a>`auditd`

audit daemon

#### Parameters

The following parameters are available in the `auditd` class:

* [`buffer_size`](#-auditd--buffer_size)
* [`failure_mode`](#-auditd--failure_mode)
* [`immutable`](#-auditd--immutable)
* [`dir`](#-auditd--dir)
* [`mode`](#-auditd--mode)
* [`owner`](#-auditd--owner)
* [`group`](#-auditd--group)
* [`config`](#-auditd--config)
* [`config_path`](#-auditd--config_path)
* [`config_mode`](#-auditd--config_mode)
* [`config_owner`](#-auditd--config_owner)
* [`config_group`](#-auditd--config_group)
* [`package_name`](#-auditd--package_name)
* [`package_ensure`](#-auditd--package_ensure)
* [`package_manage`](#-auditd--package_manage)
* [`service_enable`](#-auditd--service_enable)
* [`service_name`](#-auditd--service_name)
* [`service_ensure`](#-auditd--service_ensure)
* [`service_manage`](#-auditd--service_manage)
* [`service_override`](#-auditd--service_override)
* [`plugin_dir`](#-auditd--plugin_dir)
* [`plugin_dir_mode`](#-auditd--plugin_dir_mode)
* [`plugin_dir_owner`](#-auditd--plugin_dir_owner)
* [`plugin_dir_group`](#-auditd--plugin_dir_group)
* [`plugins`](#-auditd--plugins)
* [`rules_dir`](#-auditd--rules_dir)
* [`rules_dir_mode`](#-auditd--rules_dir_mode)
* [`rules_dir_owner`](#-auditd--rules_dir_owner)
* [`rules_dir_group`](#-auditd--rules_dir_group)
* [`rules_file`](#-auditd--rules_file)
* [`rules_file_mode`](#-auditd--rules_file_mode)
* [`rules_file_owner`](#-auditd--rules_file_owner)
* [`rules_file_group`](#-auditd--rules_file_group)
* [`rules`](#-auditd--rules)

##### <a name="-auditd--buffer_size"></a>`buffer_size`

Data type: `Integer`

The buffer size to use

Default value: `8192`

##### <a name="-auditd--failure_mode"></a>`failure_mode`

Data type: `Integer`

The failure mode (defaults to printing failure message)

Default value: `1`

##### <a name="-auditd--immutable"></a>`immutable`

Data type: `Boolean`

Set if the configuration should be immutable

Default value: `false`

##### <a name="-auditd--dir"></a>`dir`

Data type: `Stdlib::Absolutepath`

The auditd configuration directory path (e.g. /etc/audit)

Default value: `'/etc/audit'`

##### <a name="-auditd--mode"></a>`mode`

Data type: `Stdlib::Filemode`

The auditd configuration directory mode

Default value: `'0750'`

##### <a name="-auditd--owner"></a>`owner`

Data type: `Variant[String[1], Integer]`

The auditd configuration directory owner

Default value: `0`

##### <a name="-auditd--group"></a>`group`

Data type: `Variant[String[1], Integer]`

The auditd configuration directory group

Default value: `0`

##### <a name="-auditd--config"></a>`config`

Data type: `Auditd::Conf`

auditd.conf configuration hash

Default value: `{}`

##### <a name="-auditd--config_path"></a>`config_path`

Data type: `Stdlib::Absolutepath`

auditd.conf configuration filepath (e.g. /etc/audit/auditd.conf)

Default value: `'/etc/audit/auditd.conf'`

##### <a name="-auditd--config_mode"></a>`config_mode`

Data type: `Stdlib::Filemode`

The configurtion file mode

Default value: `'0600'`

##### <a name="-auditd--config_owner"></a>`config_owner`

Data type: `Variant[String[1], Integer]`

The configurtion file mode owner

Default value: `0`

##### <a name="-auditd--config_group"></a>`config_group`

Data type: `Variant[String[1], Integer]`

The configurtion file mode group

Default value: `0`

##### <a name="-auditd--package_name"></a>`package_name`

Data type: `String[1]`

The package name to use

Default value: `'auditd'`

##### <a name="-auditd--package_ensure"></a>`package_ensure`

Data type: `String`

The package state to set

Default value: `'installed'`

##### <a name="-auditd--package_manage"></a>`package_manage`

Data type: `Boolean`

If the auditd package should be managed

Default value: `true`

##### <a name="-auditd--service_enable"></a>`service_enable`

Data type: `Boolean`

The service enable state

Default value: `true`

##### <a name="-auditd--service_name"></a>`service_name`

Data type: `String[1]`

The service name to use

Default value: `'auditd'`

##### <a name="-auditd--service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`

The service ensure state

Default value: `'running'`

##### <a name="-auditd--service_manage"></a>`service_manage`

Data type: `Boolean`

If the auditd service should be managed

Default value: `true`

##### <a name="-auditd--service_override"></a>`service_override`

Data type: `Optional[String]`

auditd service override content

Default value: `undef`

##### <a name="-auditd--plugin_dir"></a>`plugin_dir`

Data type: `Stdlib::Absolutepath`

The plugin directory path to manage

Default value: `'/etc/audit/plugins.d'`

##### <a name="-auditd--plugin_dir_mode"></a>`plugin_dir_mode`

Data type: `Stdlib::Filemode`

The plugin directory mode

Default value: `'0750'`

##### <a name="-auditd--plugin_dir_owner"></a>`plugin_dir_owner`

Data type: `Variant[String[1], Integer]`

The plugin directory owner

Default value: `0`

##### <a name="-auditd--plugin_dir_group"></a>`plugin_dir_group`

Data type: `Variant[String[1], Integer]`

The plugin directory group

Default value: `0`

##### <a name="-auditd--plugins"></a>`plugins`

Data type: `Hash[String, Auditd::Plugins]`

Hash of auditd plugin configuration files to create

Default value: `{}`

##### <a name="-auditd--rules_dir"></a>`rules_dir`

Data type: `Stdlib::Absolutepath`

The rules directory path to manage

Default value: `'/etc/audit/rules.d'`

##### <a name="-auditd--rules_dir_mode"></a>`rules_dir_mode`

Data type: `Stdlib::Filemode`

The rules directory mode

Default value: `'0750'`

##### <a name="-auditd--rules_dir_owner"></a>`rules_dir_owner`

Data type: `Variant[String[1], Integer]`

The rules directory owner

Default value: `0`

##### <a name="-auditd--rules_dir_group"></a>`rules_dir_group`

Data type: `Variant[String[1], Integer]`

The rules directory group

Default value: `0`

##### <a name="-auditd--rules_file"></a>`rules_file`

Data type: `Stdlib::Absolutepath`

The rules filepath

Default value: `'/etc/audit/rules.d/audit.rules'`

##### <a name="-auditd--rules_file_mode"></a>`rules_file_mode`

Data type: `Stdlib::Filemode`

The rules file mode

Default value: `'0600'`

##### <a name="-auditd--rules_file_owner"></a>`rules_file_owner`

Data type: `Variant[String[1], Integer]`

The rules file owner

Default value: `0`

##### <a name="-auditd--rules_file_group"></a>`rules_file_group`

Data type: `Variant[String[1], Integer]`

The rules file group

Default value: `0`

##### <a name="-auditd--rules"></a>`rules`

Data type: `Hash[String, Auditd::Rules]`

Hash of auditd rules to set

Default value: `{}`

### <a name="auditd--audisp"></a>`auditd::audisp`

audit event dispatcher

#### Parameters

The following parameters are available in the `auditd::audisp` class:

* [`dir`](#-auditd--audisp--dir)
* [`mode`](#-auditd--audisp--mode)
* [`owner`](#-auditd--audisp--owner)
* [`group`](#-auditd--audisp--group)
* [`config`](#-auditd--audisp--config)
* [`config_path`](#-auditd--audisp--config_path)
* [`config_mode`](#-auditd--audisp--config_mode)
* [`config_owner`](#-auditd--audisp--config_owner)
* [`config_group`](#-auditd--audisp--config_group)
* [`package_name`](#-auditd--audisp--package_name)
* [`package_ensure`](#-auditd--audisp--package_ensure)
* [`package_manage`](#-auditd--audisp--package_manage)
* [`plugin_dir`](#-auditd--audisp--plugin_dir)
* [`plugin_dir_mode`](#-auditd--audisp--plugin_dir_mode)
* [`plugin_dir_owner`](#-auditd--audisp--plugin_dir_owner)
* [`plugin_dir_group`](#-auditd--audisp--plugin_dir_group)
* [`plugins`](#-auditd--audisp--plugins)

##### <a name="-auditd--audisp--dir"></a>`dir`

Data type: `Stdlib::Absolutepath`

The auditd configuration directory path

Default value: `'/etc/audisp'`

##### <a name="-auditd--audisp--mode"></a>`mode`

Data type: `Stdlib::Filemode`

The auditd configuration directory mode

Default value: `'0750'`

##### <a name="-auditd--audisp--owner"></a>`owner`

Data type: `Variant[String[1], Integer]`

The auditd configuration directory owner

Default value: `0`

##### <a name="-auditd--audisp--group"></a>`group`

Data type: `Variant[String[1], Integer]`

The auditd configuration directory group

Default value: `0`

##### <a name="-auditd--audisp--config"></a>`config`

Data type: `Auditd::Audisp::Conf`

audispd.conf configuration hash

Default value: `{}`

##### <a name="-auditd--audisp--config_path"></a>`config_path`

Data type: `Stdlib::Absolutepath`

audispd.conf file path

Default value: `'/etc/audisp/audispd.conf'`

##### <a name="-auditd--audisp--config_mode"></a>`config_mode`

Data type: `Stdlib::Filemode`

audispd.conf file mode

Default value: `'0600'`

##### <a name="-auditd--audisp--config_owner"></a>`config_owner`

Data type: `Variant[String[1], Integer]`

audispd.conf file owner

Default value: `0`

##### <a name="-auditd--audisp--config_group"></a>`config_group`

Data type: `Variant[String[1], Integer]`

audispd.conf file group

Default value: `0`

##### <a name="-auditd--audisp--package_name"></a>`package_name`

Data type: `String[1]`

The audisp plugins package name

Default value: `'audispd-plugins'`

##### <a name="-auditd--audisp--package_ensure"></a>`package_ensure`

Data type: `String`

The package state to set

Default value: `'installed'`

##### <a name="-auditd--audisp--package_manage"></a>`package_manage`

Data type: `Boolean`

If the audisp plugin package should be managed

Default value: `true`

##### <a name="-auditd--audisp--plugin_dir"></a>`plugin_dir`

Data type: `Stdlib::Absolutepath`

The plugin directory path to manage

Default value: `'/etc/audisp/plugins.d'`

##### <a name="-auditd--audisp--plugin_dir_mode"></a>`plugin_dir_mode`

Data type: `Stdlib::Filemode`

The plugin directory mode

Default value: `'0750'`

##### <a name="-auditd--audisp--plugin_dir_owner"></a>`plugin_dir_owner`

Data type: `Variant[String[1], Integer]`

The plugin directory owner

Default value: `0`

##### <a name="-auditd--audisp--plugin_dir_group"></a>`plugin_dir_group`

Data type: `Variant[String[1], Integer]`

The plugin directory group

Default value: `0`

##### <a name="-auditd--audisp--plugins"></a>`plugins`

Data type: `Hash[String, Auditd::Plugins]`

Hash of audisp plugin configuration files to create

Default value: `{}`

## Defined types

### <a name="auditd--plugin"></a>`auditd::plugin`

Create plugin files

#### Parameters

The following parameters are available in the `auditd::plugin` defined type:

* [`active`](#-auditd--plugin--active)
* [`direction`](#-auditd--plugin--direction)
* [`path`](#-auditd--plugin--path)
* [`type`](#-auditd--plugin--type)
* [`args`](#-auditd--plugin--args)
* [`format`](#-auditd--plugin--format)
* [`plugin_type`](#-auditd--plugin--plugin_type)
* [`mode`](#-auditd--plugin--mode)
* [`owner`](#-auditd--plugin--owner)
* [`group`](#-auditd--plugin--group)

##### <a name="-auditd--plugin--active"></a>`active`

Data type: `Enum['yes', 'no']`

Set the plugin active state.

Default value: `'yes'`

##### <a name="-auditd--plugin--direction"></a>`direction`

Data type: `Enum['in', 'out']`

Give a clue to the event dispatcher about which direction events flow.

Default value: `'out'`

##### <a name="-auditd--plugin--path"></a>`path`

Data type: `Variant[Stdlib::Absolutepath, String]`

The absolute path to the plugin executable.

##### <a name="-auditd--plugin--type"></a>`type`

Data type: `Enum['builtin', 'always']`

Tells the dispatcher how the plugin wants to be run.

Default value: `'always'`

##### <a name="-auditd--plugin--args"></a>`args`

Data type: `Optional[String]`

Pass arguments to the child program.

Default value: `undef`

##### <a name="-auditd--plugin--format"></a>`format`

Data type: `Enum['binary', 'string']`

Binary or string dispatcher options.

Default value: `'string'`

##### <a name="-auditd--plugin--plugin_type"></a>`plugin_type`

Data type: `Enum['auditd', 'audisp']`

The plugin type

Default value: `'auditd'`

##### <a name="-auditd--plugin--mode"></a>`mode`

Data type: `Stdlib::Filemode`

The file mode to apply

Default value: `'0600'`

##### <a name="-auditd--plugin--owner"></a>`owner`

Data type: `Variant[String, Integer]`

The file owner to set

Default value: `0`

##### <a name="-auditd--plugin--group"></a>`group`

Data type: `Variant[String, Integer]`

The file group to set

Default value: `0`

### <a name="auditd--rule"></a>`auditd::rule`

Creates auditd rules

#### Parameters

The following parameters are available in the `auditd::rule` defined type:

* [`content`](#-auditd--rule--content)
* [`order`](#-auditd--rule--order)

##### <a name="-auditd--rule--content"></a>`content`

Data type: `Optional[String]`

The rule content

Default value: `undef`

##### <a name="-auditd--rule--order"></a>`order`

Data type: `Integer[1, 1000]`

The rule priority order (between 1 and 1000)

Default value: `10`

## Data types

### <a name="Auditd--Audisp--Conf"></a>`Auditd::Audisp::Conf`

audispd.conf configuration file parameters

Alias of

```puppet
Struct[{
    Optional['q_depth']         => Integer,
    Optional['overflow_action'] => Enum['ignore', 'IGNORE', 'syslog', 'SYSLOG', 'suspend', 'SUSPEND', 'single', 'SINGLE', 'halt', 'HALT'],
    Optional['priority_boost']  => Integer[0],
    Optional['max_restarts']    => Integer[0],
    Optional['name_format']     => Enum['none', 'NONE', 'hostname', 'HOSTNAME', 'fqd', 'FQD', 'numeric', 'NUMERIC', 'user', 'USER'],
    Optional['name']            => String,
    Optional['plugin_dir']      => Stdlib::Absolutepath,
  }]
```

### <a name="Auditd--Conf"></a>`Auditd::Conf`

auditd.conf configuration file parameters

Alias of

```puppet
Struct[{
    Optional['local_events']            => Enum['yes', 'no'],
    Optional['log_file']                => Stdlib::Absolutepath,
    Optional['write_logs']              => Enum['yes', 'no'],
    Optional['log_format']              => Enum['raw', 'RAW', 'enriched', 'ENRICHED'],
    Optional['log_group']               => Variant[Integer, String[1]],
    Optional['priority_boost']          => Integer[0],
    Optional['flush']                   => Enum[
      'none',
      'NONE',
      'incremental',
      'INCREMENTAL',
      'incremental_async',
      'INCREMENTAL_ASYNC',
      'data',
      'DATA',
      'sync',
      'SYNC',
    ],
    Optional['freq']                    => Integer[0],
    Optional['dispatcher']              => String,
    Optional['disp_qos']                => Enum['lossy', 'LOSSY', 'lossless', 'LOSSLESS'],
    Optional['num_logs']                => Integer[0, 999],
    Optional['name_format']             => Enum['none', 'NONE', 'hostname', 'HOSTNAME', 'fqd', 'FQD', 'numeric', 'NUMERIC', 'user', 'USER'],
    Optional['name']                    => String,
    Optional['max_log_file']            => Integer,
    Optional['max_log_file_action']     => Enum[
      'ignore',
      'IGNORE',
      'syslog',
      'SYSLOG',
      'suspend',
      'SUSPEND',
      'rotate',
      'ROTATE',
      'keep_logs',
    'KEEP_LOGS'],
    Optional['verify_email']            => Enum['yes', 'no'],
    Optional['action_mail_acct']        => Variant[String, Stdlib::Email],
    Optional['space_left']              => Integer,
    Optional['space_left_action']       => Enum[
      'ignore',
      'IGNORE',
      'syslog',
      'SYSLOG',
      'rotate',
      'ROTATE',
      'email',
      'EMAIL',
      'exec',
      'EXEC',
      'suspend',
      'SUSPEND',
      'single',
      'SINGLE',
      'halt',
    'HALT'],
    Optional['admin_space_left']        => Variant[Integer, String],
    Optional['admin_space_left_action'] => Enum[
      'ignore',
      'IGNORE',
      'syslog',
      'SYSLOG',
      'rotate',
      'ROTATE',
      'email',
      'EMAIL',
      'exec',
      'EXEC',
      'suspend',
      'SUSPEND',
      'single',
      'SINGLE',
      'halt',
      'HALT',
    ],
    Optional['disk_full_action']        => Enum['ignore',
      'IGNORE',
      'syslog',
      'SYSLOG',
      'rotate',
      'ROTATE',
      'exec',
      'EXEC',
      'suspend',
      'SUSPEND',
      'single',
      'SINGLE',
      'halt',
      'HALT',
    ],
    Optional['disk_error_action']       => Enum['ignore',
      'IGNORE',
      'syslog',
      'SYSLOG',
      'exec',
      'EXEC',
      'suspend',
      'SUSPEND',
      'single',
      'SINGLE',
      'halt',
      'HALT',
    ],
    Optional['tcp_listen_port']         => Integer[1,65535],
    Optional['tcp_listen_queue']        => Integer,
    Optional['tcp_max_per_addr']        => Integer[1,1024],
    Optional['use_libwrap']             => Enum['yes', 'no'],
    Optional['tcp_client_ports']        => Variant[Integer, String],
    Optional['tcp_client_max_idle']     => Integer,
    Optional['transport']               => Enum['tcp', 'TCP', 'krb5', 'KRB5'],
    Optional['enable_krb5']             => Enum['yes', 'no'],
    Optional['krb5_principal']          => String,
    Optional['krb5_key_file']           => Stdlib::Absolutepath,
    Optional['distribute_network']      => Enum['yes', 'no'],
    Optional['q_depth']                 => Integer,
    Optional['overflow_action']         => Enum['ignore',
      'IGNORE',
      'syslog',
      'SYSLOG',
      'suspend',
      'SUSPEND',
      'single',
      'SINGLE',
      'halt',
      'HALT',
    ],
    Optional['max_restarts']            => Integer[0],
    Optional['plugin_dir']              => Stdlib::Absolutepath,
    Optional['end_of_event_timeout']    => Integer[0],
  }]
```

### <a name="Auditd--Plugins"></a>`Auditd::Plugins`

auditd plugin parameters

Alias of

```puppet
Struct[{
    Optional['active']      => Enum['yes', 'no'],
    Optional['direction']   => Enum['in', 'out'],
    'path'                  => Variant[Stdlib::Absolutepath, String],
    Optional['type']        => Enum['builtin', 'always'],
    Optional['args']        => String,
    Optional['format']      => Enum['binary', 'string'],
    Optional['plugin_type'] => Enum['auditd', 'audisp'],
    Optional['mode']        => Stdlib::Filemode,
    Optional['owner']       => Variant[String, Integer],
    Optional['group']       => Variant[String, Integer],
  }]
```

### <a name="Auditd--Rules"></a>`Auditd::Rules`

auditd rule parameters

Alias of

```puppet
Struct[{
    Optional['content'] => String,
    Optional['order']   => Integer[1, 999],
  }]
```

